package owl.main.exposure;

import java.awt.Color;
import java.util.EventObject;


public class ExposeEvent extends EventObject
{
	private static final long serialVersionUID = 8961159959385359915L;

	public Color	color;
	public int		elapsedTime;
	public int		minPixelCount;
	public int		maxPixelCount;
	public int		pixelCount;
	public int		frameCount;


	public ExposeEvent( Object oSource )
	{
		super( oSource );

		setToZero();
	}

	//  Parameter passed as a float for overloading
	// +--------------------------------------------+
	public ExposeEvent( Object oSource, float fElapsedTime )
	{
		super( oSource );

		setToZero();

		elapsedTime = ( int )fElapsedTime;
	}

	public ExposeEvent( Object oSource, int dPixelCount )
	{
		super( oSource );

		setToZero();

		pixelCount = dPixelCount;
	}

	public ExposeEvent( Object oSource, long lFrame )
	{
		super( oSource );

		setToZero();

		frameCount = ( int )lFrame;
	}

	public ExposeEvent( Object oSource, int dMin, int dMax )
	{
		super( oSource );

		setToZero();

		minPixelCount = dMin;
		maxPixelCount = dMax;
	}

	public ExposeEvent( Object oSource, Color cColor )
	{
		super( oSource );

		setToZero();

		color = cColor;
	}

	private void setToZero()
	{
		color			= Color.BLACK;
		elapsedTime		= 0;
		minPixelCount	= 0;
		maxPixelCount	= 0;
		pixelCount		= 0;
		frameCount		= 0;
	}
}
