package owl.main.fits;

import java.io.File;

import owl.img.buffer.ImageUpdateEvent;
import owl.main.MainApp;
import owl.main.owltypes.OwlFileChooser;
import arc.api.device.ArcDeviceJAPI;
import arc.api.fits.ArcFitsFileJAPI;
import arc.api.image.ArcImageJAPI;



public class FitsLoader
{
	private File m_file;


	public FitsLoader()
	{
		m_file = new File( System.getProperty( "user.dir" ) );
	}

	public void load()
	{
		OwlFileChooser fileChooser = new OwlFileChooser( m_file, "fit" );

		long lFitsFile = 0;

		try
		{
			if ( fileChooser.openDialog() )
			{
				m_file = fileChooser.getSelectedFile().getParentFile();

				lFitsFile = ArcFitsFileJAPI.Open(
											fileChooser.getFileAsString() );

				long lFitsBufVA = ArcFitsFileJAPI.Read( lFitsFile );

				long lCols = ArcFitsFileJAPI.GetCols( lFitsFile );
				long lRows = ArcFitsFileJAPI.GetRows( lFitsFile );

				long lFitsBufSize =	2 * lRows * lCols;

				ArcImageJAPI.Copy( ArcDeviceJAPI.GetCommonBufferVA(),
								   ArcDeviceJAPI.GetCommonBufferSize(),
								   lFitsBufVA,
								   ( int )lFitsBufSize );

				ImageUpdateEvent.callImageBufferListeners(
											new ImageUpdateEvent(
													this,
													lRows,
													lCols,
													fileChooser.getFileAsString() ) );
			}
		}
		catch ( Exception e )
		{
			MainApp.error( e.getMessage() );
		}
		finally
		{
			if ( lFitsFile != 0 )
			{
				try
				{
					ArcFitsFileJAPI.Close( lFitsFile );
				}
				catch ( Exception ex ) {}
			}
		}
	}
}
