package owl.main.setup;

import java.io.FileInputStream;
import java.util.ArrayList;

import javax.swing.JOptionPane;

import org.apache.commons.digester3.Digester;

//import owl.CCParams.CCScript;
import owl.CCParams.CCScriptGroup;



public class DeviceScriptDigester
{
	// +---------------------------------------------------------------------------+
	// | run
	// +---------------------------------------------------------------------------+
	// | Parses a set of device configuration scripts.
	// |
	// | /params
	// | /params/pci
	// | /params/pci/devscript
	// | /params/pci/devscript/script
	// | /params/pci/devscript/text
	// | /params/pci/devscript/action
	// |
	// | /params
	// | /params/pcie
	// | /params/pcie/devscript
	// | /params/pcie/devscript/script
	// | /params/pcie/devscript/text
	// | /params/pcie/devscript/action
	// +---------------------------------------------------------------------------+
	public ArrayList<CCScriptGroup> run( String sXMLFileName )
	{
		ArrayList<CCScriptGroup> list = null;

		try
		{
			Digester digester = new Digester();

			digester.setValidating( false );

			digester.addObjectCreate( "params", "java.util.ArrayList" );

			//  PCI devices
			// +--------------------------------------------------------------------------+
			digester.addObjectCreate( "params/pci", "owl.CCParams.CCScriptGroup" );
			digester.addSetNext( "params/pci", "add", "owl.CCParams.CCScriptGroup" );
			digester.addCallMethod( "params/pci/name", "setName", 0 );

			digester.addObjectCreate( "params/pci/devscript", "owl.CCParams.CCScript" );
			digester.addCallMethod( "params/pci/devscript/script", "setScript", 0 );
			digester.addCallMethod( "params/pci/devscript/text",   "setText", 0 );
			digester.addCallMethod( "params/pci/devscript/action", "setAction", 0 );

			digester.addSetNext( "params/pci/devscript", "add", "owl.CCParams.CCScript" );

			//  PCIe devices
			// +--------------------------------------------------------------------------+
			digester.addObjectCreate( "params/pcie", "owl.CCParams.CCScriptGroup" );
			digester.addSetNext( "params/pcie", "add", "owl.CCParams.CCScriptGroup" );
			digester.addCallMethod( "params/pcie/name", "setName", 0 );

			digester.addObjectCreate( "params/pcie/devscript", "owl.CCParams.CCScript" );
			digester.addCallMethod( "params/pcie/devscript/script", "setScript", 0 );
			digester.addCallMethod( "params/pcie/devscript/text",   "setText", 0 );
			digester.addCallMethod( "params/pcie/devscript/action", "setAction", 0 );

			digester.addSetNext( "params/pcie/devscript", "add", "owl.CCParams.CCScript" );

			//  This method starts the parsing of the document.
			// +----------------------------------------------------------+
			list = digester.parse( new FileInputStream( sXMLFileName ) );
		}
		catch ( Exception e )
		{
			JOptionPane.showMessageDialog( null,
										   "Failed to properly parse DEVICE XML file! " +
										    e.getMessage(),
											"Device XML Parser",
											JOptionPane.ERROR_MESSAGE );
		}

		return list;
	}
}
