package owl.main.setup;

import java.io.FileInputStream;
import java.util.ArrayList;

import javax.swing.JOptionPane;

import org.apache.commons.digester3.Digester;

import owl.CCParams.CCScriptGroup;



public class ParamScriptDigester
{
	// +---------------------------------------------------------------------------+
	// | run
	// +---------------------------------------------------------------------------+
	// | Parses the controller configuration xml file with the following pattern:
	// |
	// | /params
	// | /params/group
	// | /params/group/ccscript - Optional properties: infoOnly="true",oneOnly="true"
	// | /params/group/ccscript/script
	// | /params/group/ccscript/text
	// | /params/group/ccscript/action
	// | /params/group/ccscript/bits
	// |
	// | /params
	// | /params/group
	// | /params/group/dcscript
	// | /params/group/dcscript/script
	// | /params/group/dcscript/text
	// | /params/group/dcscript/action
	// | /params/group/dcscript/bits
	// +---------------------------------------------------------------------------+
	public ArrayList<CCScriptGroup> run( String sXMLFileName )
	{
		ArrayList<CCScriptGroup> list = null;

		try
		{
			Digester digester = new Digester();

			digester.setValidating( false );

			digester.addObjectCreate( "params", "java.util.ArrayList" );

			digester.addObjectCreate( "params/group", "owl.CCParams.CCScriptGroup" );
			digester.addSetNext( "params/group", "add", "owl.CCParams.CCScriptGroup" );

			//  CC Scripts
			// +--------------------------------------------------------------------------+
			digester.addObjectCreate( "params/group/ccscript", "owl.CCParams.CCScript" );
			digester.addSetProperties( "params/group/ccscript" );

			digester.addCallMethod( "params/group/ccscript/script",   "setScript",   0 );
			digester.addCallMethod( "params/group/ccscript/text",     "setText",     0 );
			digester.addCallMethod( "params/group/ccscript/action",   "setAction",   0 );
			digester.addCallMethod( "params/group/ccscript/bits",     "setBits",     0 );

			digester.addSetNext( "params/group/ccscript", "add", "owl.CCParams.CCScript" );

			//  DC Scripts
			// +--------------------------------------------------------------------------+
			digester.addObjectCreate( "params/group/dcscript", "owl.CCParams.CCScript" );

			digester.addCallMethod( "params/group/dcscript/script", "setScript", 0 );
			digester.addCallMethod( "params/group/dcscript/text",   "setText",   0 );
			digester.addCallMethod( "params/group/dcscript/action", "setAction", 0 );
			digester.addCallMethod( "params/group/dcscript/bits",   "setBits",   0 );

			digester.addSetNext( "params/group/dcscript", "add", "owl.CCParams.CCScript" );


			//  This method starts the parsing of the document.
			// +----------------------------------------------------------+
			list = digester.parse( new FileInputStream( sXMLFileName ) );
		}
		catch ( Exception e )
		{
			JOptionPane.showMessageDialog( null,
										   "Failed to properly parse PARAM XML file! " +
										   e.getMessage(),
										   "ParamScript XML Parser",
										   JOptionPane.ERROR_MESSAGE );
		}

		return list;
	}
}
